=== debian/control ===
Source: ros-melodic-mrt-cmake-modules
Section: misc
Priority: optional
Maintainer: Fabian Poggenhans <fabian.poggenhans@kit.edu>
Build-Depends: debhelper (>= 9.0.0), python-catkin-pkg-modules, python-rospkg, python-setuptools, python-yaml, ros-melodic-catkin, ros-melodic-ros-environment
Homepage: http://wiki.ros.org/mrt_cmake_modules
Standards-Version: 3.9.2

Package: ros-melodic-mrt-cmake-modules
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lcov, python-catkin-pkg-modules, python-rospkg, python-setuptools, python-yaml, ros-melodic-ros-environment
Description: CMake Functions and Modules for automating CMake
